module: dylan-user

define library test-framework
  use dylan;
  use streams;
  use standard-io;
  use format-out;

  use reflection;

  export test-framework;
end library;

define module test-framework
  create <test>, <test-case>, <test-suite>;
  create test-case-description, test-case-test;
  create test-suites, test-suite, test-suite-setter;
  create set-up-test, tear-down-test;
  create add-test;
  
  create <test-runner>;
  create run-all-tests, run-all-known-tests;
  
  create <test-failure>;
  create fail-test;
  create expect, expect-value, expect-instance;
  create <unexpected-failure>;
  
  // These shouldn't be necessary for normal operation
  create run-tests, run-test-case;
  create print-test-summary;
  create print-runner-failures, print-failure;
end module;

define module test-framework-internals
  use dylan;
  use extensions;
  use conditions; // This should be a standard module
  use streams;
  use standard-io;
  use format-out;

  use reflection;
  
  use test-framework;
end module test-framework-internals;